// C Source File
// Created 16/02/01; 00:13:24

// #define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include <c:\dev\ti89\tkf.h>

short _ti92plus;              // Produce .9XZ File
short _ti89;                  /* Produce .89Z File	*/


void sprint(void);
extern void drawsprint(int,int);
int subkey1(void);
void swim(void);
void drawswim(int,int,int);
extern void FillColorRect(int,int,int,int);
extern void input_str(int,int);
extern int endofgame(void);
extern void about(void);
extern void intro(void);
void help(void);

char retire=0;
double top_score[2];
char top_name[2][20]={"cedric","cedric"};
double score;
int sel=1, fin;
unsigned int old_key=8;

INT_HANDLER oldint5 = NULL;

volatile int mseconds50; // counts in 50ms steps (not exact 50ms, but 1000/19 ms)
volatile int seconds; // counts seconds

DEFINE_INT_HANDLER (myint5handler) {
        mseconds50++;
        score+=0.05;
        if (mseconds50 == 19) {
            mseconds50 = 0;
            seconds++;
            score=(int)score+1; //to be exact
        }
    ExecuteHandler(oldint5);
}


void help(void)
{
 SCR_RECT fullscreen={{0,0,159,99}},rect={{115,10,147,41}};
 unsigned long arrow[2][31]={{57344,202752,279552,582144,651776,1308928,1048832,787968,260096,12583008,52429048,69206268,145752542,160432590,328204743,395313603,328204743,160432590,143655390,69206268,52429048,12583008,260096,787968,1048832,1308928,651776,582144,279552,202752,57344},{57344,202752,279552,582144,651776,1308928,1048832,787968,260096,12583008,65011864,132120708,258998562,242221362,477102393,409993533,477102393,242221362,258998562,132120708,65011864,12583008,260096,787968,1048832,1308928,651776,582144,279552,202752,57344}};
 clrscr();
 oldint5 = GetIntVec(AUTO_INT_5);
 SetIntVec(AUTO_INT_5, myint5handler);
 score=0;
 FontSetSys(F_8x10);
 printf_xy(8,1,"How to play?");
 FontSetSys(F_4x6);
 printf_xy(1,15,"To make the athlete run or");
 printf_xy(1,21,"swim,push intermitently");
 printf_xy(1,27,"left and right");
 printf_xy(1,33,"now,if you don't understand");
 printf_xy(1,39,"you're realy stupid...");
 printf_xy(1,45,"press 2nd");
 while(!(_rowread(0xFE)&16))
  {
  if(score<0.1)
    {
    ScrRectFill(&rect,&fullscreen, A_REVERSE);
    Sprite32(115,10,31,arrow[0],LCD_MEM,SPRT_XOR);
    }
  if(score<0.6&&score>=0.5)
   {
   ScrRectFill(&rect,&fullscreen, A_REVERSE);
   Sprite32(115,10,31,arrow[1],LCD_MEM,SPRT_XOR);
   }
   if(score==1) score=0;
  }
 SetIntVec(AUTO_INT_5, oldint5); 
}


// Main Function
void _main(void)
{
FILE *scorep; /*C file pointer*/
SYM_ENTRY *filep; /*VAT file pointer*/
LCD_BUFFER buffer;      //Gets the screen
LCD_save(buffer);
filep = SymFindPtr($(tkfscore), 0); /*see if the high score file exists*/
if(filep != NULL) /*if it does*/
	if(filep->flags.bits.archived) /*and it is archived*/
		EM_moveSymFromExtMem($(tkfscore), HS_NULL); /*unarchive it*/
scorep = fopen("tkfscore", "rb+"); /*try to open the file that the scores are saved in*/
if(scorep == NULL) /*if the file does not exist*/
{
// make the file
	scorep = fopen("tkfscore", "wb");
	top_score[0]=13.1;
	top_score[1]=150;
	fwrite(&top_score[0],sizeof(double),2,scorep);
	fwrite(&top_name[0][0],1,40,scorep);
	
	putc(0,scorep);
	fputs("TKF", scorep);
	putc(0, scorep);
	putc(OTH_TAG, scorep);
}
else /*if the file does exist*/
{
	/*get the high scores from the file*/
	fread(&top_score[0],sizeof(double),2,scorep);
   fread(&top_name[0][0],1,40,scorep);
	
	
	
}
fclose(scorep);

// ===========================
//  starting of main routines
// ===========================
deb:
do{
 intro();
 score=0;
 retire=0;
 clrscr();
 switch(sel)
  {
   case 1:	sprint();
   			break;
   case 2:	swim();
   			break;
   case 3:	about();
   			goto deb;
   case 4:  help();
   			goto deb;
  }
  } while(endofgame()==1);
scorep = fopen("tkfscore", "rb+");
fwrite(&top_score[0],sizeof(double),2,scorep);
fwrite(&top_name[0][0],1,40,scorep);
fclose(scorep);
EM_moveSymToExtMem($(tkfscore), HS_NULL); /*archive the file*/
LCD_restore(buffer);
}


void swim(void)
{
 // nageur commence a nager vers la droite (cote=1)
 // 400m soit 2 aller retour
 int x=0,lenght=400,cur_lenght=0,cote=1,num=1;
 old_key=8;
 mseconds50=0;
 seconds=0;
 FontSetSys(F_8x10);
 drawswim(1,1,0);
 printf_xy(5,50,"READY??..");
 ngetchx();
 clrscr();
 fin=0;
 drawswim(num,1,x);
 oldint5 = GetIntVec(AUTO_INT_5);
 SetIntVec(AUTO_INT_5, myint5handler);
 while(cur_lenght<lenght&&!retire)
 {
  retire=_rowread(0xBF)&1;
  printf_xy(5,50,"lenght left %d m ",lenght-cur_lenght);
  printf_xy(5,63,"TIME: %f  ",score);
  printf_xy(5,80,"WR:%f      ",top_score[1]);
  if(subkey1())  //not 2 keys twice
   {
    num++;
    if(num==3) num=0;
    x+=cote;
    cur_lenght++;
    drawswim(num,cote>0,x);
    if(x==100||x==0)
     	cote=-cote;
   }
 }
 SetIntVec(AUTO_INT_5, oldint5);
}

void drawswim(int num,int where,int x)
{
 int var;
 // swimmer(65,5)
 // 1m (=) 5pxl
 clrscr();
 Sprite32(65, 10, 29, swimmer[where][num], LCD_MEM, SPRT_XOR);
 if(x<13)	DrawLine(65-x*5,0,65-x*5,45,A_NORMAL);
 if(x>87)	DrawLine(97+(100-x)*5,0,97+(100-x)*5,45,A_NORMAL);
 DrawLine(0,4,159,4,A_NORMAL);
 DrawLine(0,6,159,6,A_NORMAL);
 DrawLine(0,44,159,44,A_NORMAL);
 DrawLine(0,46,159,46,A_NORMAL);
 if(where)
 {
 if(fin==0) fin=30;
 else fin-=5;
 }
 else
 {
 if(fin==30) fin=0;
 else fin+=5;
 }
 for(var=0;var<5;var++)
  {
  	DrawLine(fin+var*30,5,fin+var*30+15,5,A_NORMAL);
  	DrawLine(fin+var*30,45,fin+var*30+15,45,A_NORMAL);
  }
}

void sprint(void)
{
int x=20,num=2,lenght=100;
old_key=8;
mseconds50=0;
fin=0;
seconds=0;
FontSetSys(F_8x10);
drawsprint(1,20);
printf_xy(5,55,"READY??..");
ngetchx();
clrscr();
drawsprint(num,x);
oldint5 = GetIntVec(AUTO_INT_5);
SetIntVec(AUTO_INT_5, myint5handler);
while((fin<10)&&!retire){
 retire=_rowread(0xBF)&1;
 printf_xy(5,55,"lenght left %d m ",lenght);
 printf_xy(5,68,"TIME: %f  ",score);
 printf_xy(5,85,"WR:%f      ",top_score[0]);
 if(subkey1())  //not 2 keys twice
  {
  	num++;
  	if(num==3) num=0;
  	x-=6;
  	if(x<0) 
  	 {
  	 x+=60;
  	 lenght-=10;
  	 fin++;
  	 }
  	drawsprint(num,x);
  }
 }
SetIntVec(AUTO_INT_5, oldint5);
}


int subkey1(void)
{
 unsigned int key,k1;
 k1=_rowread(ARROWS_ROW);
 key=(k1&8)-(k1&2);
 if(old_key!=key && key && key!=6)  //not 2 keys twice
  	{
  	old_key=key;
   return (int)1;
	}
 else
   return (int)0;
}

